/*
    v0.01 - original


Usage:      add to Auto Start
            it runs and terminates
            to remove; remove from autostart and reboot

    12.88 firmware only
    this tap disables dsmcc to prevent the toppy from crashing on bbc
    this may prevent some of the interactive services from running on all channels (not just bbc)
*/

#include <tap.h>

#define ID_USERTAP 0xbdb01601
TAP_ID( ID_USERTAP );

TAP_PROGRAM_NAME("prevent_dsmcc_crash v0.01");
TAP_AUTHOR_NAME("bdb");
TAP_DESCRIPTION("A TAP to prevent the DSMCC crash on bbc");
TAP_ETCINFO(__DATE__);

#define pSysID          0xa3fffffa
extern int _appl_version;

//----------------------------------------------------------------------------
int TAP_Main(void)
{
    //determine firmware version
    if ((*(word*)pSysID != 456) || (_appl_version != 0x1288)) {
        TAP_Print("\nUnsupported platform - %d:%04x", *(word*)pSysID, _appl_version);
        return 0;
    }

//8019e48c 51 c0 00 05   beqzl   $t6, 0x8019e4a4           --> 8019e48c 10 00 00 05   b 0x8019e67c
//8019e490 00 00 10 25   move    $v0, $0
//8019e494 30 5e ff ff   andi    $fp, $v0, 0xffff
//8019e498 53 c0 00 04   beqzl   $fp, 0x8019e4ac
//8019e49c 93 be 00 20   lbu     $fp, 0x20($sp)
//8019e4a0 00 00 10 25   move    $v0, $0
//8019e4a4 10 00 00 75   b       0x8019e67c                --> exit

    *(dword *)0x8019e48c = 0x10000005;

    return 0;                 //0=application mode, 1=tsr mode
}

//----------------------------------------------------------------------------
dword TAP_EventHandler(word event, dword param1, dword param2)
{
    return param1;
}
